$regfile = "attiny13.dat"
$crystal = 1200000

$hwstack = 32                                               ' default use 32 for the hardware stack
$swstack = 8                                                ' default use 10 for the SW stack
$framesize = 16                                             ' default use 40 for the frame space

' Alias defines                                                         LED-Gruppen
I_s Alias Pinb.0                                            ' Eingang fr Schalter
O_1 Alias Portb.3                                           ' LED-Gruppe 1                 2   4   3
O_2 Alias Portb.2                                           ' LED-Gruppe 2
O_3 Alias Portb.1                                           ' LED-Gruppe 3                     1
O_4 Alias Portb.4                                           ' LED-Gruppe 4
                                        '                               3   4   2

'Dimensionierung von Variablen
Dim Zahl As Word
Dim B As Byte

' Forward declarations von Funktionen
Declare Sub Zeigezahl                                       ' Wurf anzeigen
Declare Sub Findezahl
Declare Sub Taste

'---------- Initialisierung aller notwendigen Controlregister-Bits
Config Clockdiv = 8

'Config Portb = Output
Config Pinb.0 = Input
Config Portb.3 = Output                 ' LED Gruppe 1 - 7
Config Portb.2 = Output                 ' LED-Gruppe 2 - 5+6
Config Portb.1 = Output                 ' LED-Gruppe 3 - 3+4
Config Portb.4 = Output                 ' LED-Gruppe 4 - 1+2

'Config Powermode = Powerdown

'On Pcint0 Taste                                             ' bei PinChangeIRQ auf Pin 5 wurde Taste gedrckt

Portb.0 = 1                                                 ' internen PullUp an Pin PB0 (=Pin 5) einschalten

'---------- Ende Initialisierung aller notwendigen Controlregister-Bits

'---------- PinChange-IRQ freigeben -----------------
'Enable Interrupts
'Enable Pcint0

For Zahl = 0 To 7
   Zeigezahl
'   Toggle O_1
   Waitms 100
Next Zahl
Zahl = 0
Zeigezahl

' ------------- Hauptschleife Start -------------
Do
   'Start Watchdog                       ' WD einschalten
   'Powerdown                                                ' CPU anhalten, Clocks aus -> Strom sparen

   ' hier gehts nach WakeUp from PowerDown durch Tasten-IRQ weiter...
   'Disable Pcint0
   'Findezahl

   Bitwait I_s , Reset
'   Debounce I_s , 0 , Findezahl , Sub                       ' 25 ms entprellen

   While I_s = 0
      Incr Zahl
   Wend

   Zahl = Zahl Mod 6
   Incr Zahl


   For B = 0 To 2
      Zeigezahl
      Waitms 100
      Portb = 1                                             ' bit 0 muss 1 bleiben, damit der PullUp an der Taste eingeschaltet bleibt
      Waitms 200
   Next B
'      Waitms 500

   'Enable Pcint0                                            ' IRQ fr Taste aktivieren
Loop

' ------------- Hauptschleife Ende -------------

' --------------Interrupt-Routinen--------------
' ------------------------------------------------------------
'Taste:
'   Toggle Portb.3
'   'Debounce I_s , 0 , Findezahl         ' 25 ms entprellen
'   Zahl = Rnd(6) + 1
'Return
' --------------Interrupt-Routinen Ende----------

'Findezahl:
'   Zahl = Rnd(7) + 1
'Return

' ------------------------------------------------------------
'                                                               LED-Gruppen
'O_1 Alias Portb.3       = 2^3 =  8  = 0x08    ' LED-Gruppe 1    2   4   3
'O_2 Alias Portb.2       = 2^2 =  4  = 0x04    ' LED-Gruppe 2
'O_3 Alias Portb.1       = 2^1 =  2  = 0x02    ' LED-Gruppe 3        1
'O_4 Alias Portb.4       = 2^4 = 16  = 0x10    ' LED-Gruppe 4
'                                              '                 3   4   2

Zeigezahl:
   Select Case Zahl
      Case 0:
         Portb = 1                                          ' alles aus
      Case 1:
         Portb = 9                                          ' 0x08
      Case 2:
         Portb = 5                                          ' 0x04
      Case 3:
         Portb = 13                                         ' 0x0C
      Case 4:
         Portb = 7                                          ' 0x06
      Case 5:
         Portb = 15                                         ' 0x0E
      Case 6:
         Portb = 23                                         ' 0x16
      Case 7:
         Portb = 31                                         ' 0x1E
   End Select

Return

' ------------------------------------------------------------
End